Index: kernel/application.php
===================================================================
--- kernel/application.php	(revision 13782)
+++ kernel/application.php	(working copy)
@@ -829,14 +829,12 @@
 		$serial_name = $pascal_case_prefix . (isset($id) ? 'IDSerial:' . $id : 'Serial');
 
 		if ($increment) {
-			if ($this->isCachingType(CACHING_TYPE_MEMORY)) {
-				if (defined('DEBUG_MODE') && DEBUG_MODE && $this->isDebugMode()) {
-					$this->Application->Debugger->appendHTML('Incrementing serial: <strong>' . $serial_name . '</strong>.');
-				}
-
-				$this->setCache($serial_name, (int)$this->getCache($serial_name) + 1);
+			if (defined('DEBUG_MODE') && DEBUG_MODE && $this->isDebugMode()) {
+				$this->Application->Debugger->appendHTML('Incrementing serial: <strong>' . $serial_name . '</strong>.');
 			}
 
+			$this->setCache($serial_name, (int)$this->getCache($serial_name) + 1);
+
 			if (!defined('IS_INSTALL') || !IS_INSTALL) {
 				// delete cached mod-rewrite urls related to given prefix and id
 				$delete_clause = isset($id) ? $prefix . ':' . $id : $prefix;
Index: kernel/utility/cache.php
===================================================================
--- kernel/utility/cache.php	(revision 13756)
+++ kernel/utility/cache.php	(working copy)
@@ -213,10 +213,6 @@
 		 */
 		function prepareKeyName($name, $replace_serials = true)
 		{
-			if ($this->cachingType == CACHING_TYPE_TEMPORARY) {
-				return $name;
-			}
-
 			// replace serials in key name
 			if ($replace_serials && preg_match_all('/\[%(.*?)%\]/', $name, $regs)) {
 				// [%LangSerial%] - prefix-wide serial in case of any change in "lang" prefix
@@ -227,6 +223,10 @@
 				}
 			}
 
+			if ($this->cachingType == CACHING_TYPE_TEMPORARY) {
+				return $name;
+			}
+
 			// add site-wide prefix to key
 			return $this->_cachePrefix() . $name;
 		}
